image: m1ka05/julia-feather:1.10.6-latest # image comes from Docker hub

variables:
  DOC_TEST_DEPLOY: "yes" # if set to "yes", docs will fix jldoctests (round-up error, etc...)

before_script:
  - julia --project=@. .gitlab-ci-prep.jl
  - python3 -m venv feather_venv; source feather_venv/bin/activate
  - python3 -m pip install lcov_cobertura
      
default:
  stage: test
  coverage: '/\(\d+.\d+\%\) covered/'
  script:
    - julia --project=@. -e "import Pkg; Pkg.instantiate(); Pkg.test(; coverage = true)"
    - julia --project=test/coverage -e "import Pkg; Pkg.instantiate()"
    - julia --project=test/coverage test/coverage/process_coverage.jl
    - lcov_cobertura lcov.info --output coverage.xml
  artifacts:
    expire_in: 5 days
    reports:
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml
pages:
  stage: deploy
  script:
    - julia --project=docs -e 'using Pkg; Pkg.develop(PackageSpec(path=pwd())); Pkg.instantiate(); '
    - julia --project=docs --color=yes docs/make.jl
    - mv docs/build public
  artifacts:
    paths:
      - public
  only:
  - master
